"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createResponseAjv = exports.createRequestAjv = void 0;
const ajv_1 = require("ajv");
const ajv_formats_1 = require("ajv-formats");
const formats_1 = require("./formats");
function createRequestAjv(openApiSpec, options = {}) {
    return createAjv(openApiSpec, options);
}
exports.createRequestAjv = createRequestAjv;
function createResponseAjv(openApiSpec, options = {}) {
    return createAjv(openApiSpec, options, false);
}
exports.createResponseAjv = createResponseAjv;
function createAjv(openApiSpec, options = {}, request = true) {
    var _a;
    const ajv = new ajv_1.default(Object.assign(Object.assign({ strictTypes: false, discriminator: true, allErrors: true, jsPropertySyntax: true, coerceTypes: 'array' }, options), { logger: {
            log(...args) { console.log(...args); },
            warn(...args) {
                var _a;
                if (!((_a = arguments[0]) === null || _a === void 0 ? void 0 : _a.match('jsPropertySyntax'))) {
                    console.warn(...args);
                }
            },
            error(...args) { console.error(...args); }
        } }));
    ajv_formats_1.default(ajv);
    Object.keys(Object.assign(Object.assign({}, formats_1.formats), options.formats)).forEach(formatKey => {
        ajv.addFormat(formatKey, formats_1.formats[formatKey]);
    });
    ajv.removeKeyword('propertyNames');
    ajv.removeKeyword('contains');
    ajv.removeKeyword('const');
    ajv.addKeyword({ keyword: 'paths' });
    ajv.addKeyword({ keyword: 'components' });
    ajv.addKeyword({ keyword: 'example' });
    if ((_a = openApiSpec.components) === null || _a === void 0 ? void 0 : _a.schemas) {
        Object.entries(openApiSpec.components.schemas).forEach(([id, schema]) => {
            ajv.addSchema(openApiSpec.components.schemas[id], `#/components/schemas/${id}`);
        });
    }
    return ajv;
}
//# sourceMappingURL=index.js.map