"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.UnsupportedMediaType = exports.BadRequest = exports.HttpError = exports.SerDesSingleton = void 0;
class SerDesSingleton {
    constructor(param) {
        this.format = param.format;
        this.serialize = param.serialize;
        this.deserialize = param.deserialize;
        this.deserializer = {
            format: param.format,
            deserialize: param.deserialize
        };
        this.serializer = {
            format: param.format,
            serialize: param.serialize
        };
    }
}
exports.SerDesSingleton = SerDesSingleton;
;
class HttpError extends Error {
    constructor(err) {
        var _a;
        super(err.name);
        this.name = err.name;
        this.status = err.status;
        this.path = err.path;
        this.message = err.message;
        this.headers = err.headers;
        this.errors = (_a = err.errors) !== null && _a !== void 0 ? _a : [
            {
                path: err.path,
                message: err.message,
            },
        ];
    }
}
exports.HttpError = HttpError;
class BadRequest extends HttpError {
    constructor(err) {
        super({
            status: err.overrideStatus || 400,
            path: err.path,
            name: 'Bad Request',
            message: err.message,
            errors: err.errors,
        });
    }
}
exports.BadRequest = BadRequest;
class UnsupportedMediaType extends HttpError {
    constructor(err) {
        super({
            status: err.overrideStatus || 415,
            path: err.path,
            name: 'Unsupported Media Type',
            message: err.message,
        });
    }
}
exports.UnsupportedMediaType = UnsupportedMediaType;
//# sourceMappingURL=types.js.map